#include "stdafx.h"
#include "common.hpp"

struct FarList List;
struct FarListItem *ListItems;

HWND farwnd;

TSwitchToThisWindow SwitchToThisWindow = NULL;
TAllowSetForegroundWindow AllowSetForegroundWindow = NULL;

void SwitchToWindow(HWND hwnd)
{
  SetForegroundWindow(hwnd);
  Sleep(20);

/*  if (!AllowSetForegroundWindow)
    AllowSetForegroundWindow = (TAllowSetForegroundWindow)GetProcAddress(GetModuleHandle("user32.dll"), "AllowSetForegroundWindow");

  if (AllowSetForegroundWindow) 
  {
    DWORD dwProcessId = 0;
    GetWindowThreadProcessId(hwnd, &dwProcessId);
    if (dwProcessId)
    {
      AllowSetForegroundWindow(dwProcessId);
      
      DWORD dwResult;
      SendMessageTimeout(hwnd, WM_ACTIVATE, 0, 0, SMTO_ABORTIFHUNG, 1000, &dwResult);
    }
  }*/

  if (!SwitchToThisWindow)
    SwitchToThisWindow = (TSwitchToThisWindow)GetProcAddress(GetModuleHandle("user32.dll"), "SwitchToThisWindow");
  
  if (SwitchToThisWindow)
  {
    HWND hwndLastActive = GetLastActivePopup(hwnd);

    if (IsWindowVisible(hwndLastActive))
      hwnd = hwndLastActive;

    if (SwitchToThisWindow) 
      SwitchToThisWindow(hwnd, TRUE);
  }
} 

void BlinkWindow(HWND hwnd)
{  
  RECT        rect;
  HWND        startWindow;
  PAINTSTRUCT lpPaint;

  if (!IsWindow(hwnd))
    return;
  
  startWindow = GetForegroundWindow();

  SwitchToWindow(GetThreadWnd(hwnd));

  int _SM_CYVSCROLL = GetSystemMetrics(SM_CYVSCROLL);
  int _SM_CXHSCROLL = GetSystemMetrics(SM_CXHSCROLL);
  int _SM_CXSCREEN = GetSystemMetrics(SM_CXSCREEN);
  int _SM_CYSCREEN = GetSystemMetrics(SM_CYSCREEN);

  HDC hdc = GetWindowDC(hwnd);
  SetROP2(hdc, R2_NOT);

  DWORD color = GetSysColor(COLOR_WINDOWFRAME);
  HBRUSH brush = CreateSolidBrush(color);
  HGDIOBJ oldBrush = SelectObject(hdc, brush);

  HRGN rgn = CreateRectRgn(0, 0, 0, 0);
  int wndRgn = GetWindowRgn(hwnd, rgn);
  if (wndRgn == ERROR)
  {
    if (IsZoomed(hwnd))
    {
      SetRect(&rect,
        _SM_CYVSCROLL, _SM_CXHSCROLL, 
        _SM_CXSCREEN + _SM_CYVSCROLL, _SM_CYSCREEN + _SM_CXHSCROLL);
    }
    else
    {
      GetWindowRect(hwnd, &rect);
      MapWindowPoints(NULL, hwnd, (LPPOINT)&rect, 2);
    }
  }

  for (int n = 0; n < 10; n++) 
  {
    BeginPaint(hwnd, &lpPaint);
    if (n%2 == 0)
    {
      FullRedrawWindow(hwnd);
    }
    else
    {
      if (wndRgn == ERROR)
        FillRect(hdc, &rect, brush);
      else
        FillRgn(hdc, rgn, brush);
    }
    EndPaint(hwnd, &lpPaint);
    Sleep(50);
  }

  FullRedrawWindow(hwnd);

  DeleteObject(rgn);
  SelectObject(hdc, oldBrush);
  ReleaseDC(hwnd, hdc);

  SwitchToWindow(startWindow);
}

void DrawFocusRectangle(HWND hwnd)
{
  RECT rect;

  int _SM_CXBORDER = GetSystemMetrics(SM_CXBORDER);
  int _SM_CYBORDER = GetSystemMetrics(SM_CYBORDER);
  int _SM_CYVSCROLL = GetSystemMetrics(SM_CYVSCROLL);
  int _SM_CXHSCROLL = GetSystemMetrics(SM_CXHSCROLL);
  int _SM_CXSCREEN = GetSystemMetrics(SM_CXSCREEN);
  int _SM_CYSCREEN = GetSystemMetrics(SM_CYSCREEN);

  HDC hdc = GetWindowDC(hwnd);
  SetROP2(hdc, R2_NOT);

  HPEN pen = CreatePen(PS_INSIDEFRAME, _SM_CXBORDER * 3, 0);
  HGDIOBJ oldPen = SelectObject(hdc, pen);
  HGDIOBJ brush = GetStockObject(NULL_BRUSH);
  HGDIOBJ oldBrush = SelectObject(hdc, brush);

  HRGN rgn = CreateRectRgn(0, 0, 0, 0);
  if (GetWindowRgn(hwnd, rgn) == ERROR)
  {
    if (IsZoomed(hwnd))
      SetRect(&rect, 
        _SM_CYVSCROLL, _SM_CXHSCROLL, 
        _SM_CXSCREEN + _SM_CYVSCROLL, _SM_CYSCREEN + _SM_CXHSCROLL);
    else
    {
      GetWindowRect(hwnd, &rect);
      SetRect(&rect, 0, 0, rect.right - rect.left, rect.bottom - rect.top);
    }
    Rectangle(hdc, rect.left, rect.top, rect.right, rect.bottom);
  }
  else
  {
    DWORD color = GetSysColor(COLOR_WINDOWFRAME);
    HBRUSH rgnBrush = CreateHatchBrush(HS_DIAGCROSS, color);
    FrameRgn(hdc, rgn, rgnBrush, _SM_CXBORDER * 3, _SM_CYBORDER * 3);
    DeleteObject(rgnBrush);
  }

  DeleteObject(rgn);
  SelectObject(hdc, oldBrush);
  SelectObject(hdc, oldPen);
  ReleaseDC(hwnd, hdc);
  DeleteObject(pen);
}

void FullRedrawWindow(HWND hwnd)
{
  RECT rect;

  int _SM_CYVSCROLL = GetSystemMetrics(SM_CYVSCROLL);
  int _SM_CXHSCROLL = GetSystemMetrics(SM_CXHSCROLL);
  int _SM_CXSCREEN = GetSystemMetrics(SM_CXSCREEN);
  int _SM_CYSCREEN = GetSystemMetrics(SM_CYSCREEN);

  HRGN rgn = CreateRectRgn(0, 0, 0, 0);
  int wndRgn = GetWindowRgn(hwnd, rgn);

  if (wndRgn == ERROR)
  {
    if (IsZoomed(hwnd))
    {
      SetRect(&rect,
        _SM_CYVSCROLL, _SM_CXHSCROLL, 
        _SM_CXSCREEN + _SM_CYVSCROLL, _SM_CYSCREEN + _SM_CXHSCROLL);
    }
    else
    {
      GetWindowRect(hwnd, &rect);
      MapWindowPoints(NULL, hwnd, (LPPOINT)&rect, 2);
    }
  }

  RedrawWindow(hwnd, 
    (wndRgn == ERROR) ? &rect : NULL, 
    (wndRgn == ERROR) ? NULL : rgn, 
    RDW_ERASE|RDW_FRAME|RDW_INVALIDATE|RDW_ALLCHILDREN|RDW_UPDATENOW);

  if (IsZoomed(hwnd))
  {
    GetWindowRect(hwnd, &rect);
    InvalidateRect(hwnd, &rect, TRUE);
    SendMessage(hwnd, WM_NCPAINT, 0, 0);
  }
}

HWND GetThreadWnd(HWND hwnd)
{
  HWND wndThread = hwnd;
  while (GetParent(wndThread))
    wndThread = GetParent(wndThread);
  
  return wndThread;
}

/* Regular StrToInt; stops at first non-digit. */
int  StrToInt(const char* lpSrc)      // atoi()
{

#define ISDIGIT(c)  ((c) >= TEXT('0') && (c) <= TEXT('9'))

    int n = 0;
    BOOL bNeg = FALSE;

    if (*lpSrc == TEXT('-')) {
        bNeg = TRUE;
        lpSrc++;
    }

    while (ISDIGIT(*lpSrc)) {
        n *= 10;
        n += *lpSrc - TEXT('0');
        lpSrc++;
    }
    return bNeg ? -n : n;
}

