#include "stdafx.h"
#include "dlgevents.hpp"
#include "far.hpp"
#include "dialog.hpp"
#include "common.hpp"
#include "wndlist.hpp"
#include "options.hpp"
#include "wll_Spy.hpp"
#include "find.hpp"
#include "terminate.hpp"
#include "msg.hpp"
#include "filter.hpp"

//#include "..\hook\hook.hpp"

long WINAPI DlgProc(HANDLE hDlg, int Msg, int Param1, long Param2)
{
  static int ActionListPos = 0;
  long result;
  
  switch (Msg) 
  {
  case DN_INITDIALOG:
    if (dlgMainOnInitDialog(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
    
  case DN_GOTFOCUS:
    if (dlgMainOnGotFocus(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;

  case DN_ENTERIDLE:
    if (dlgMainOnEnterIdle(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;

  case DN_KEY:
    if (dlgMainOnKey(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
  case DN_HOTKEY:
    if (dlgMainOnHotKey(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;

  case DN_CTLCOLORDLGITEM:
    if (dlgMainOnCtlColorDlgItem(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
    
  case DN_EDITCHANGE:
    if (dlgMainOnEditChange(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
      
  case DN_BTNCLICK:
    if (dlgMainOnBtnClick(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;

  case DN_LISTCHANGE:
    if (dlgMainOnListChange(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
    
  case DN_MOUSECLICK:
    if (dlgMainOnMouseClick(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
        
  case DN_MOUSEEVENT:
    if (dlgMainOnMouseEvent(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;

  case DN_CLOSE:
    if (dlgMainOnClose(hDlg, Msg, Param1, Param2, &result))
      return result;
    break;
  }
  
  return Info.DefDlgProc(hDlg, Msg, Param1, Param2);
}

BOOL dlgMainOnInitDialog(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Param1;
  (void) Param2;

  //  DN_MOUSEEVENT
  Info.SendDlgMessage(hDlg, DM_SETMOUSEEVENTNOTIFY , 1, 0);

  // " "
  //(struct List   OpenPlugin)
  Info.SendDlgMessage(hDlg, DM_LISTSET, lbActions, (long)&List);

  //       ,    
  Info.SendDlgMessage(hDlg, DM_SETCURSORSIZE, edWindowsList, 0);
  Info.SendDlgMessage(hDlg, DM_SETCURSORSIZE, cbWindowsList, 0);

  //  
  SetWindowsListItems(hDlg);
  
  //     edWindowsList
  DlgItem_SetFocus(Info, hDlg, edWindowsList);
  //   DN_GOTFOCUS   
  Info.SendDlgMessage(hDlg, DN_GOTFOCUS, edWindowsList, 0);

  *Result = FALSE;
  return TRUE;
};

BOOL dlgMainOnClose(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) hDlg;
  (void) Msg;
  (void) Param2;

  //   (KEY_ESC  KEY_F10)    <>
  *Result = (Param1 == -1 || Param1 == btnCloseDialog || Param1 == -10);

  return TRUE;
};

BOOL dlgMainOnGotFocus(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Param2;

  //     
  SetDlgItemStr(hDlg, laHelp, GetItemHelp(Param1));

  switch (Param1)
  {
  //combobox    
  case cbWindowsList:
    Info.SendDlgMessage(hDlg, DM_SETFOCUS, edWindowsList, 0);
    *Result = FALSE;
    return TRUE;
  }

  return FALSE;
};

BOOL dlgMainOnEnterIdle(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) hDlg;
  (void) Msg;
  (void) Param1;
  (void) Param2;
  (void) Result;

  return FALSE;
}

BOOL dlgMainOnKey(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Param1;

  *Result = TRUE;

  switch (Param2)
  {
  //     <Ctrl>+<Shift>+<F9>
  case KEY_ALT|KEY_SHIFT|KEY_F9:
    if (theOptions->ShowDialog())
    {
      //  <>
      //      
      ResizeDialog(hDlg, &MainDlgParams, theOptions->Value(opt_MainDlgWidth)->IntValue, 0, TRUE);

      // " "    "  "
      SetWindowsListItems(hDlg);
    };
    return TRUE;

  //    
  case KEY_SHIFT|KEY_CTRL|KEY_RIGHT :
    ResizeDialog(hDlg, &MainDlgParams, MainDlgParams.width + 1, 0, TRUE);
    return TRUE;
  case KEY_SHIFT|KEY_CTRL|KEY_LEFT:
    ResizeDialog(hDlg, &MainDlgParams, MainDlgParams.width - 1, 0, TRUE);
    return TRUE;

  //,     
  case KEY_ALT|KEY_COMMA:
    if (Info.SendDlgMessage(hDlg, DM_ENABLE, btnWindowPrev, -1))
      Info.SendDlgMessage(hDlg, DN_BTNCLICK, btnWindowPrev, 0);
    return TRUE;
  case KEY_ALT|KEY_DOT:
    if (Info.SendDlgMessage(hDlg, DM_ENABLE, btnWindowSucc, -1))
      Info.SendDlgMessage(hDlg, DN_BTNCLICK, btnWindowSucc, 0);
    return TRUE;

  ///  
  case KEY_CTRLH:
    {
      BOOL bShowHidden = !theOptions->Value(opt_WLShowHidden)->IntValue;
      theOptions->SetBool(opt_WLShowHidden, bShowHidden);
      SetWindowsListItems(hDlg);

      //       (  )
      //      
      char buf[512];
      wsprintf(buf, "%s\n%s\n%s %d", 
        GetMsg(MPluginTitle), 
        bShowHidden ? GetMsg(MShowHiddenOn) : GetMsg(MShowHiddenOff),
        GetMsg(MWindowsCount),
        theSpyWindows->Count());
      Info.Message(Info.ModuleNumber,
        FMSG_ALLINONE|FMSG_MB_OK,
        NULL,
        (const char * const *)buf,
        0,0);
    }
    return TRUE;
  
    //  <Ctrl>+<Down>   ComboBox+Edit
  case KEY_CTRL|KEY_DOWN:
    if (Param1 == cbWindowsList || Param1 == edWindowsList)
    {
      if (!Info.SendDlgMessage(hDlg, DM_GETDROPDOWNOPENED, cbWindowsList, 0))
      {
        Info.SendDlgMessage(hDlg, DM_SETDROPDOWNOPENED, cbWindowsList, TRUE);
      }
    }
    return TRUE;
  }
  
  *Result = FALSE;
  return TRUE;
}

BOOL dlgMainOnHotKey(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void)Msg;
  (void)Param2;

  static BOOL workaround_WLHotKey = FALSE;

  switch (Param1)
  {
      case cbWindowsList:
        if (!workaround_WLHotKey)
          Info.SendDlgMessage(hDlg, DN_MOUSECLICK, edWindowsList, 0);
        workaround_WLHotKey = !workaround_WLHotKey;
        *Result = FALSE;
        return TRUE;
  } 
  
  *Result = TRUE;
  return TRUE;
}

BOOL dlgMainOnCtlColorDlgItem(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) hDlg;
  (void) Msg;
  (void) Param2;

  int color;

  switch (Param1)
  {
  case staticHelpBox:
    color = Info.AdvControl(Info.ModuleNumber, ACTL_GETCOLOR, (void*)COL_HELPBOX);
    *Result = 0x30303030;
    return TRUE;
  case laHelp:
    color = Info.AdvControl(Info.ModuleNumber, ACTL_GETCOLOR, (void*)COL_HELPTEXT);
    *Result = color;
    return TRUE;
  }
  
  return FALSE;
}

BOOL dlgMainOnBtnClick(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Param2;

  switch (Param1)
  {
  case btnFilterSet:
  case cbUseFilter:
    {
      if (Param1 == btnFilterSet)
        SetFilter(&wndFilter);

      BOOL InFilterMode = Info.SendDlgMessage(hDlg, DM_GETCHECK, cbUseFilter, 0) == BSTATE_CHECKED;
    
      if (InFilterMode || Param1 == cbUseFilter)
        SetWindowsListItems(hDlg);

      *Result = (Param1 == btnFilterSet) ? FALSE : TRUE;
      return TRUE;
    }

  case btnWLRefresh:
    SetWindowsListItems(hDlg);
    *Result = FALSE;
    return TRUE;

  case btnBlinkWindow:
    BlinkWindow(wndInfo.hwnd);
    *Result = FALSE;
    return TRUE;

  //  /  
  case btnWindowPrev:
  case btnWindowSucc:
    {
    struct WindowHistoryItem historyItem;
    if (Param1 == btnWindowPrev)
      theWindowsHistory->Prev(&historyItem);
    else
      theWindowsHistory->Succ(&historyItem);
    
    //        
    theSpyWindows->GetWindowInfo(historyItem.hwnd, &wndInfo);
    FillDialog(hDlg, &wndInfo, FALSE);

    *Result = FALSE;
    return TRUE;
    }
  }

  return FALSE;
}

BOOL dlgMainOnListChange(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Result;

  int CurPos;
  SpyWindow item;
  char buf[MAXSIZE];

  switch (Param1)
  {
  //     " " (combobox)
  case edWindowsList:
  case cbWindowsList:
    //         
    CurPos = Info.SendDlgMessage(hDlg, DM_LISTGETCURPOS, cbWindowsList, 0);
    item = *theSpyWindows->Items(CurPos);
    //     
    //     opt_WLHelpFormat
    //    
    if (theSpyWindows->GetFormatString(item.Window, 
      theOptions->Value(opt_WLHelpFormat)->StrValue, &buf[0], sizeof(buf)))
    {
      SetDlgItemStr(hDlg, laHelp, buf);
    }
    break;
  
  // 
  case cbDependsWindows:
    SetDlgItemStr(hDlg, laHelp, GetItemHelp(wndDependOwner + Param2));
    break;
  
  // 
  case cbRectValue:
    SetDlgItemStr(hDlg, laHelp, GetItemHelp(wndRectRectangle + Param2));
    break;
  }
  
  return FALSE;
}

BOOL dlgMainOnEditChange(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Param2;

  int CurPos;
  
  HWND hwnd;

  switch (Param1)
  {
  case cbWindowsList:
    CurPos = Info.SendDlgMessage(hDlg, DM_LISTGETCURPOS, cbWindowsList, 0);
    hwnd = (HWND)Info.SendDlgMessage(hDlg, DM_LISTGETDATA, cbWindowsList, CurPos);
    theSpyWindows->GetWindowInfo(hwnd, &wndInfo);
    FillDialog(hDlg, &wndInfo, TRUE);
    *Result = TRUE;
    return TRUE;

  case cbDependsWindows:
    CurPos = Info.SendDlgMessage(hDlg, DM_LISTGETCURPOS, cbDependsWindows, 0);
    if (wndInfo.dependsWindows[CurPos] != 0)
      theSpyWindows->GetWindowInfo(wndInfo.dependsWindows[CurPos], &wndInfo);
    FillDialog(hDlg, &wndInfo, TRUE);
    *Result = FALSE;
    return TRUE;

  case cbHistory:
    theSpyWindows->GetWindowInfo(theHistory->GetHWND(hDlg), &wndInfo);
    FillDialog(hDlg, &wndInfo, TRUE);
    return TRUE;
  }

  return FALSE;
}

BOOL dlgMainOnMouseClick(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;

  MOUSE_EVENT_RECORD m_record;
  SMALL_RECT ItemRect;
  SMALL_RECT DlgRect;
  int CurPos;
  BOOL f;

  switch (Param1)
  {
  //   ""    
  case laCloseDialog:
    Info.SendDlgMessage(hDlg, DM_CLOSE, btnCloseDialog, 0);
    *Result = FALSE;
    return TRUE;

  /// combobox       edWindowsList
  case edWindowsList:
    //  
    f = Info.SendDlgMessage(hDlg, DM_GETDROPDOWNOPENED, 0, 0);
    //   -   
    Info.SendDlgMessage(hDlg, DM_SETDROPDOWNOPENED, cbWindowsList, (long)!f);
    *Result = TRUE;
    return TRUE;

  case lbActions:
    m_record = *(MOUSE_EVENT_RECORD*)Param2;
      
    if (m_record.dwButtonState == FROM_LEFT_1ST_BUTTON_PRESSED &&
        m_record.dwEventFlags == 0)
    {
      Info.SendDlgMessage(hDlg, DM_GETITEMPOSITION, lbActions, (long)&ItemRect);
      Info.SendDlgMessage(hDlg, DM_GETDLGRECT, 0, (long)&DlgRect);
      
      CurPos = Info.SendDlgMessage(hDlg, DM_LISTGETCURPOS, lbActions, 0);

      if ((m_record.dwMousePosition.X >= DlgRect.Left + ItemRect.Left) && 
         (m_record.dwMousePosition.X <= DlgRect.Left + ItemRect.Right) &&
         (m_record.dwMousePosition.Y >= DlgRect.Top + ItemRect.Top + CurPos) && 
         (m_record.dwMousePosition.Y <= DlgRect.Top + ItemRect.Bottom + CurPos)) 
      {
        WindowActions actionID;

        switch (CurPos + actionShow) 
        {
        case actionEnable:
          actionID = WA_ENABLE;
          EnableWindow(wndInfo.hwnd, TRUE);
          break;
        case actionDisable:
          actionID = WA_DISABLE;
          EnableWindow(wndInfo.hwnd, FALSE);
          break;
        case MClose:
          actionID = WA_CLOSE;
          SendMessage(wndInfo.hwnd, WM_CLOSE, 0, 0);
          break;
        case actionDestroy:
          actionID = WA_DESTROY;
          spyTerminateProcess(wndInfo.ProcessID);
          Sleep(100);
          *Result = TRUE;
          return TRUE;
          break;
        default:
          ShowWindow(wndInfo.hwnd, CmdShow[CurPos]);
          actionID = (WindowActions)CurPos;
        }
        
        theHistory->Add(hDlg, wndInfo.hwnd, actionID);

        SetActions(hDlg, wndInfo.hwnd);
        *Result = TRUE;
        return TRUE;
      }
    }
  }

  return FALSE;
}

BOOL dlgMainOnMouseEvent(HANDLE hDlg, int Msg, int Param1, long Param2, long *Result)
{
  (void) Msg;
  (void) Param1;
  (void) Result;

  SMALL_RECT DlgRect;
  SMALL_RECT ItemRect;
  MOUSE_EVENT_RECORD m_record = *(MOUSE_EVENT_RECORD*)Param2;
  static int dlgMainLastHelp = -1;

  //   DI_LISTBOX`    
  struct DlgHelpListBoxItem ListBoxItems[1] = {
    lbActions, lbActionsFirst,
  };
  //      
  ShowDlgHelp(
    hDlg, &dlgMainLastHelp,
    &m_record, 
    laHelp, staticDialogBox, 
    ListBoxItems, 1);
  
  Info.SendDlgMessage(hDlg, DM_GETDLGRECT, 0, (long)&DlgRect);
  Info.SendDlgMessage(hDlg, DM_GETITEMPOSITION, btnFindWindow, (long)&ItemRect);
    
  if (m_record.dwButtonState == FROM_LEFT_1ST_BUTTON_PRESSED)
  {
    if ((m_record.dwMousePosition.X >= DlgRect.Left + ItemRect.Left) && 
       (m_record.dwMousePosition.X <= DlgRect.Left + ItemRect.Right) &&
       (m_record.dwMousePosition.Y >= DlgRect.Top + ItemRect.Top) && 
       (m_record.dwMousePosition.Y <= DlgRect.Top + ItemRect.Bottom))
    {
      //   ""    
      //     
      DoFindWindow(hDlg, theOptions->Value(opt_SwitchToProcessWnd)->IntValue);
      //       

//      if (wndInfo.hwnd != farwnd)
//      {
        AddToHistory(hDlg, wndInfo.hwnd);
//      }
    }
  }
  
  return FALSE;
}
