#include "stdafx.h"
#include "hist_wnd.hpp"

CWindowsHistory::CWindowsHistory(void)
{
  AllocItemsCount = 0;
  ItemsCount = 0;
  CurrentPos = -1;
  Items = NULL;
}

CWindowsHistory::~CWindowsHistory(void)
{
  delete[] Items;
  Items = NULL;
}

DWORD CWindowsHistory::GetCurrentState(void)
{
  DWORD result = 0;

  if (CurrentPos <= 0)
    result |= WHR_ISFIRST;
  
  if (CurrentPos >= ItemsCount - 1)
    result |= WHR_ISLAST;

  return result;
}

BOOL CWindowsHistory::Add(struct WindowHistoryItem *item)
{
  ItemsCount++;
  if (ItemsCount > AllocItemsCount)
  {
    AllocItemsCount += 1024;
    Items = (struct WindowHistoryItem*)realloc(Items, AllocItemsCount * sizeof(struct WindowHistoryItem));
    if (Items == NULL)
      return FALSE;
  }

  for (int i = ItemsCount - 1; i > CurrentPos + 1 ; i--)
  {
    Items[i] = Items[i - 1];
  }
  
  CurrentPos++;
  Items[CurrentPos] = *item;
  
  return TRUE;
}

BOOL CWindowsHistory::Prev(struct WindowHistoryItem *item)
{
  if (!item || CurrentPos < 0)
    return FALSE;

  if (CurrentPos > 0)
    CurrentPos--;
  
  *item = Items[CurrentPos];
  
  return GetCurrentState();
}

BOOL CWindowsHistory::Succ(struct WindowHistoryItem *item)
{
  if (!item)
    return FALSE;

  if (CurrentPos < ItemsCount - 1)
    CurrentPos++;
  
  *item = Items[CurrentPos];
  
  return GetCurrentState();
}
