#include "stdafx.h"
#include "standart.hpp"

char * __cdecl lstrchr (const char * string,int ch)
{
  while (*string && *string != (char)ch)
    string++;
  if (*string == (char)ch)
    return((char *)string);
  return(NULL);
}


char * __cdecl strstr (
        const char * str1,
        const char * str2
        )
{
        char *cp = (char *) str1;
        char *s1, *s2;

        if ( !*str2 )
            return((char *)str1);

        while (*cp)
        {
                s1 = cp;
                s2 = (char *) str2;

                while ( *s1 && *s2 && !(*s1-*s2) )
                        s1++, s2++;

                if (!*s2)
                        return(cp);

                cp++;
        }

        return(NULL);

}

char * __cdecl strchr (
        const char * string,
        int ch
        )
{
        while (*string && *string != (char)ch)
                string++;

        if (*string == (char)ch)
                return((char *)string);
        return(NULL);
}

int __cdecl strncmp (
        const char * first,
        const char * last,
        size_t count
        )
{
        if (!count)
                return(0);

        while (--count && *first && *first == *last)
        {
                first++;
                last++;
        }

        return( *(unsigned char *)first - *(unsigned char *)last );
}

#pragma warning( disable : 4706)
char * __cdecl strncat (
        char * front,
        const char * back,
        size_t count
        )
{
        char *start = front;

        while (*front++)
                ;
        front--;

        while (count--)
                if (!(*front++ = *back++))
                        return(start);

        *front = '\0';
        return(start);
}
#pragma warning( default : 4706)

char* StringReplace(char *format, char *OldPattern, char *NewPattern, int maxlen)
{
  char *pNewStr;
  char *pSearchStr;
  char *Offset;
  char *Result;
  int newlen = 0;

  Result = new char[maxlen];
  lstrcpy(Result, "");

  pSearchStr = format;
  pNewStr = format;

  while(lstrlen(pSearchStr) != 0)
  {
    Offset = strstr(pSearchStr, OldPattern);
    if (!Offset)
    {
      if (newlen + lstrlen(pNewStr) > maxlen)
        goto error_overflow;

      lstrcat(Result, pNewStr);
      break;
    }

    int len = Offset - pSearchStr;
    newlen += len + lstrlen(NewPattern) ;
    
    if (newlen > maxlen)
      goto error_overflow;

    strncat(Result, pNewStr, len);
    lstrcat(Result, NewPattern);

    pNewStr = Offset + lstrlen(OldPattern);

    pSearchStr = Offset + lstrlen(OldPattern);
  }

  lstrcpyn(format, Result, maxlen);

  delete [] Result;
  return format;

error_overflow:
  delete [] Result;
  return NULL;
}
