#ifndef __WINDOWS_HPP__
#define __WINDOWS_HPP__

enum WndTreeChar 
{
  WTC_Null,
  WTC_Next,
  WTC_NextLink,
  WTC_Link
};

typedef enum tagEnumWindowsDepends
{
  WD_FIRST = 0,

  WD_OWNER = 0,
  WD_PARENT,
  WD_HWNDFIRST,
  WD_HWNDLAST,
  WD_HWNDNEXT,
  WD_HWNDPREV,
  WD_CHILD,

  WD_LAST
} EnumWindowsDepends;

typedef enum tagEnumWindowsRects
{
  WR_RECTANGLE,
  WR_RESTORED,
  WR_CLIENT,

  WR_LAST
} EnumWindowsRects;

typedef enum tagEnumSpyFormats
{
  SF_FIRST = 0,

  SF_HWND = 0,
  
  SF_OWNER,
  SF_PARENT,
  SF_HWNDFIRST,
  SF_HWNDLAST,
  SF_HWNDNEXT,
  SF_HWNDPREV,
  SF_CHILD,

  SF_WINDOWTEXT,
  SF_CLASSNAME,

  SF_CLASSSTYE,
  SF_WINDOWSTYLE,
  SF_WINDOWEXSTYLE,

  SF_RECTANGLE,
  SF_RESTORED,
  SF_CLIENT,

  SF_THREADID,
  SF_PROCESSID,

  SF_LAST
} EnumSpyFormats;

typedef enum tagEnumFormatType
{
  FT_INT,
  FT_STR,

  FT_LAST
} EnumFormatType;

#define MAX_SPYFORMAT (16)
struct SpyFormat
{
  char *name;          //[MAX_SPYFORMAT];
  EnumFormatType type;
};

struct SpyWindow
{
  HWND  Window;
  int  Level;
  int  Index;
};

struct SpyWindowInfo
{
  HWND hwnd;
  
  HWND dependsWindows[WD_LAST];

  char windowText[MAXSIZE];
  char className[MAXSIZE];

  long classStyle;
  long windowStyle;
  long windowExStyle;

  RECT rects[WR_LAST];

  DWORD ThreadID;
  DWORD ProcessID;
};

class CSpyWindows
{
  private:
    struct SpyWindow *spyWindows;
    int AllocItemsCount;
    int ItemsCount;
    BOOL EnumerateHiden;
    int MaxLevel;
    
    void MkWindows(HWND hwnd, int level);
    BOOL FindNextLevel(int from, int level);

  public:
    CSpyWindows(void);
    ~CSpyWindows(void);

    int Count(void);
    int Find(HWND hwnd);

    struct SpyWindow* Items(int index);

    char* GetFormatString(HWND hwnd, const char* format, char* res, int maxlen);
    BOOL GetWindowInfo(HWND hwnd, struct SpyWindowInfo* info);

    int GetTreeChar(int num, int pos, int level);
    void MakeWindowList(BOOL EnumerateHiden);
    int GetMaxLevel(void);
};

BOOL GetWindowInfoStr(struct SpyWindowInfo* info, EnumSpyFormats id, char* result, int maxlen);

#endif /* __WINDOWS_HPP__ */
